package fr.llibre.ml2;

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class Celobj extends Star {
	public int NGC;	// Numéro NGC ou 0
	public int IC; // Numéro IC ou 0
	public String other; // Si pas de numero NGC ou IC
	public double rho1, rho2; // dimensions en minute
//	public String cat; // catégorie qui précise le type
	public String cx;  // Eventuelles lettres d'appellation secondaire pour les objets multiples
	
	/**
	 *   Lecture du tableau de mes objets célestes
	 *   La lecture est effectuée dans un stream, ce qui permet de lire
	 *   dans un fichier ressource.
	 *   
	 * @param isr  : InputStreamReader du fichier à lire
	 * @return     : le tableau des objets lues.
	 */
	public static Celobj[] loadObjCels(InputStreamReader isr)
	{
		final int MAXSTARS = 340;		
		int separ = '|';
		Celobj mesObjs[] = new Celobj[MAXSTARS];
		int numline = 0, nbs = 0;
		try {
			BufferedReader in = new BufferedReader(isr);
			while(nbs < MAXSTARS)
			{
				Celobj e = new Celobj(); e.other = "";			
				String str = in.readLine(); 				
				if (str == null) break; // break si fin de fichier
				numline++;
				if (str.startsWith("#")) continue;
				int n1 = 0, n2 = str.indexOf(separ);
				e.id = str.substring(n1, n2);
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				if(n2 > n1+1) e.nom = str.substring(n1, n2);
				else e.nom = "";
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				e.NGC = Integer.parseInt(str.substring(n1, n2));
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				e.IC = Integer.parseInt(str.substring(n1, n2));
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				if(n2 > n1+1) e.other = str.substring(n1, n2);
				else e.other = "";
				n1 = n2+1; n2 = str.indexOf(separ, n1);				
				e.ixCons =  Integer.parseInt(str.substring(n1, n2));				
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				e.tipe = str.substring(n1, n2);
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				e.ad0_hd = Double.parseDouble(str.substring(n1, n2));
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				e.de0_dd = Double.parseDouble(str.substring(n1, n2));
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				e.mag = Double.parseDouble(str.substring(n1, n2));
				n1 = n2+1; n2 = str.indexOf(separ, n1);
				e.rho1 = Double.parseDouble(str.substring(n1, n2));
				n1 = n2+1;
				e.rho2 = Double.parseDouble(str.substring(n1));				 
				e.vA_sda = 0.;
				e.vD_sda = 0.;
//				e.vitMod_sda = 0.;
				e.index = nbs;
				e.flCoher = true; // a priori
				mesObjs[nbs] = e;
				nbs += 1;
			}	
			in.close();
		}
		catch(Exception exc)
		{
			System.out.println("Erreur lecture fichier mes objets célestes ligne " + numline + " : " + exc.getMessage());
			exc.printStackTrace();
		}
		return mesObjs;
	}
}
