package fr.llibre.simastro;

import android.app.ListActivity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import fr.llibre.ml2.Astro;


public class SelPlanetActivity extends ListActivity {
    private TextView tvSelection;
    private int valsel = -1;
    private String items[];
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        Intent it = getIntent();
        setResult(RESULT_CANCELED, it); // Echec annoncé a priori.
        setContentView(R.layout.layout_sel_planet);
        tvSelection = (TextView) findViewById(R.id.selection);
        int np = Astro.nomPla.length;
        int n = np + 1; items = new String[n];
        for(int i = 0; i < np; i++) items[i] = Astro.nomPla[i];
        items[2] = "Soleil";
        items[np] = "Lune";
        setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, items));
        tvSelection.setText("Selectionnez un astre !");
        valsel = -1;
    }

    public void onListItemClick(ListView parent, View v, int position,
                                long id) {
        valsel = position;
        tvSelection.setText("Ok pour : " + items[position] + "?");
    }
    // Callbacks boutons Ok et CANCEL : AVAL
    public void onOkCancel1(View w)
    {
        Intent it = new Intent();
        switch(w.getId())
        {
            case R.id.button_oui :
                if (valsel >= 0)
                {
                    it.putExtra("score", valsel);
                    setResult(RESULT_OK, it);
                }
                else setResult(RESULT_CANCELED, it);
                break;
            case R.id.button_non :
                setResult(RESULT_CANCELED, it);
                break;
        }
        finish();
    }
}