package fr.llibre.simastro;

import androidx.appcompat.app.AppCompatActivity;
//import android.support.v7.app.AppCompatActivity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import fr.llibre.ml2.TwoLE;

import static java.lang.Thread.sleep;

public class SelSatelActivity extends AppCompatActivity {
    boolean selType;
    private String listSats[];
    class MyArrayAdapter extends ArrayAdapter<String>
    {
        MyArrayAdapter (String items[]) // Le contructeur appelle le super_constructeur
        {
            super(SelSatelActivity.this, R.layout.ligne, R.id.tvLigne, items);
        }
        // On surcharge uniquement cette méthode pour definir la taille
        public View getView(int pos, View vue, ViewGroup parent)
        {
            if (vue == null) vue = super.getView(pos, vue, parent);
            TextView label = (TextView) vue.findViewById(R.id.tvLigne);
            label.setTextSize(12);
            if (selType)
            {
                if (pos == noUrl) {
                    label.setBackgroundColor(Color.YELLOW);
                    tvSel = label;
                }
                else label.setBackgroundColor(Color.WHITE);;
                label.setText(TwoLE.typeSats[pos]);
            }
            else
            {
                if (pos == noSat) {
                    label.setBackgroundColor(Color.YELLOW);
                    tvSel = label;
                }
                else label.setBackgroundColor(Color.WHITE);;

                label.setText(listSats[pos]);
            }
            return(vue);
        }
    }
    private MyArrayAdapter adapterType, adapterSat;
    private ListView liste;
    private TextView tvTitre;
    private TextView tvSel;
    private int noUrl = -1;
    private int noSat = -1;

    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        // Positionne retour sur echec a priori
        Intent it = getIntent();
        setResult(RESULT_CANCELED, it);
        // AAfichage du contenu de la fenetre
        setContentView(R.layout.layout_sel_satel);
        tvTitre = (TextView) findViewById(R.id.tvSelection);
        // Fabrication liste a afficher
        int np = TwoLE.typeSats.length;
        // Creation ArrayAdapter d'affichage dans le ListView
        selType = true ; // Liste de type de satellites
        adapterType = new MyArrayAdapter(TwoLE.typeSats);
        liste = (ListView) findViewById(R.id.list);;
        liste.setDrawSelectorOnTop(false);
        // Conditionnement du listView et de son ArrayAdapter
        liste.setOnItemClickListener(clicListener);
        liste.setAdapter(adapterType);
        tvTitre.setText("Selectionnez un type de satellite !");
        noUrl = -1;
        noSat = -1;
        selType = true ; // Liste de type de satellites
    }

    // Callback pour la sélection d'une ligne
    private AdapterView.OnItemClickListener clicListener =
            new AdapterView.OnItemClickListener(){
                @Override
                public void onItemClick(AdapterView<?> parent, View v, int position, long id)
                {
                    String str;
                    TextView label = (TextView) v.findViewById(R.id.tvLigne);
                    label.setBackgroundColor(Color.YELLOW);
                    tvSel = label;
                    if (selType)
                    {
                        if (noUrl >= 0) tvSel.setBackgroundColor(Color.WHITE);
                        noUrl = position;
                        str = TwoLE.typeSats[noUrl];
                        tvTitre.setText("OK pour sélectionner \"" + str + "\"\nPatience : Accès au Web !");
                    }
                    else
                    {
                        if (noSat >= 0) tvSel.setBackgroundColor(Color.WHITE);
                        noSat = position;
                        str = listSats[noSat];
                        tvTitre.setText("OK pour sélectionner " + str);
                    }
                }
            };

    public void onOkCancel(View w) {
        boolean ok = false;
        if (selType) // cas sélection du type de satellite
        {
            if(w.getId() == R.id.button_oui)
            {
                if (noUrl >= 0)
                {
                    ok = true;
                    final String url = TwoLE.norad + TwoLE.typeSats[noUrl] + ".txt"; // Url interrogée
                    Thread readUrl = new Thread() {
                        @Override
                        public void run() {
                            listSats = TwoLE.satArray(url); // Fabrique liste sats
                            return;
                        }
                    };
                    readUrl.start();
                    while (readUrl.isAlive()) {
                        try {sleep(200);} catch (InterruptedException e) {e.printStackTrace();}
                    }
                    if (listSats != null)
                    {
                        selType = false;
                        adapterSat = new MyArrayAdapter(listSats);
                        liste.setAdapter(adapterSat);
                        noSat = -1;
                        tvTitre.setText("Sélectionnez un satellite !");
                    } else
                        Toast.makeText(this, "Echec accès liste satellites\n Connexion internet ?", Toast.LENGTH_SHORT).show();
                }
            }
            else
            {
                Intent it = new Intent();
                setResult(RESULT_CANCELED, it);
                finish();
            }
        }
        else // Cas sélection du satellite
        {
            if (w.getId() == R.id.button_oui && noSat >= 0)
            {
                ok = true; // Pour empêcher l'exécution du bloc suivant que n'empêche pas le finish() !!!
                Intent it = new Intent();
                it.putExtra("NoUrl", noUrl);
                it.putExtra("NoSat", noSat);
                setResult(RESULT_OK, it);
                finish();
            }
        }
        if(!ok) // retour à la sélection du type
        {
            selType = true;
            liste.setAdapter(adapterType);
            noUrl = -1;
            tvTitre.setText("Selectionnez un type de satellite !");
        }
    }
}